#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"
#include <stdio.h> // files


class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id);
	void open();

    void diag(char * melde);
	void loadarray();
	void makelang();
private:


#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90

#define MAX_FILENAME_LENGTH 400

#define PN_PLAY 0
#define PN_STOP 1
#define PN_DURATIONFACTOR 2
#define PN_TEXT 3
#define PN_LOOP 4
#define PN_MIDI_OUT 5
#define PN_DURATION 6
#define PN_ADMIN 7


    float *input1_buffer; // pointer to circular buffer of samples
	float *input2_buffer;
	float *input3_buffer;
	float *output1_buffer;
	
    int stat;// on off ...
    int chan;// 0 = channel 1
	int b2;//pitch     was = ( midi_msg / 0x100 ) & 0xff;
	int b3;//velocity  was = ( midi_msg / 0x10000 ) & 0xff;
    unsigned long this_midi;
	short loop;
	bool admin;

    char *text_input;
unsigned long time1;
unsigned long midi;
unsigned long start_time;
unsigned long pause_time;
struct NOTES 
{  
   unsigned long r_time;
   unsigned long r_midi;
} note;

NOTES * noten;
bool got_one;// = false;
bool memin1;
bool level1;

bool canload;      
bool PLAY;
bool waspause;

float duration , memDuration;
unsigned long flang, taki, last_take;
unsigned long pc , md;
unsigned long * tak_time;
unsigned long * tak_midi;
unsigned long * tak_lang;
int fh;	

char path[MAX_FILENAME_LENGTH];
char full_path[MAX_FILENAME_LENGTH];
char smidi_rec_name[MAX_FILENAME_LENGTH];
char smidi_play_name[MAX_FILENAME_LENGTH];
char text_filename[MAX_FILENAME_LENGTH];
char text[MAX_FILENAME_LENGTH];


errno_t err;// = -1;
errno_t err0;// = -1;
errno_t err2;// = -1;

FILE *smidi_rec_file;//  = NULL;
FILE *smidi_play_file;//  = NULL;
FILE *textfile;// = NULL;
FILE *stream;// = NULL;

state_type in_stat;
bool isnew;// = false;
bool isnew0;// = false;
bool didonce;// = false;
int done;// = 0;


struct BB
{
	char buffer[1400];
};

struct LL
{
char thisSEM[100];
};


};
#endif
